---
title: Create an On-Call notification rule for a user
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > On-Call
---

{% callout %}
# Important note for users on the following Datadog sites: app.ddog-gov.com, us2.ddog-gov.com

{% alert level="danger" %}
This product is not supported for your selected [Datadog site](https://docs.datadoghq.com/getting_started/site.md). ({% placeholder "user-datadog-site-name" /%}).
{% /alert %}

{% /callout %}

# Create an On-Call notification rule for a user{% #create-an-on-call-notification-rule-for-a-user %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                         |
| ----------------- | ------------------------------------------------------------------------------------ |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/on-call/users/{user_id}/notification-rules |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/on-call/users/{user_id}/notification-rules |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/on-call/users/{user_id}/notification-rules      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/on-call/users/{user_id}/notification-rules      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/on-call/users/{user_id}/notification-rules  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/on-call/users/{user_id}/notification-rules     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/on-call/users/{user_id}/notification-rules |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/on-call/users/{user_id}/notification-rules |

### Overview

Create a new notification rule for a user. The authenticated user must be the target user or have the `on_call_admin` permission This endpoint requires the `on_call_respond` permission.

### Arguments

#### Path Parameters

| Name                      | Type   | Description |
| ------------------------- | ------ | ----------- |
| user_id [*required*] | string | The user ID |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field     | Field                    | Type          | Description                                                                                                  |
| ---------------- | ------------------------ | ------------- | ------------------------------------------------------------------------------------------------------------ |
|                  | data [*required*]   | object        | Data for creating an on-call notification rule                                                               |
| data             | attributes               | object        | Attributes for creating or modifying an on-call notification rule.                                           |
| attributes       | category                 | enum          | Specifies the category a notification rule will apply to Allowed enum values: `high_urgency,low_urgency`     |
| attributes       | channel_settings         |  <oneOf> | Configuration for the associated channel, if necessary                                                       |
| channel_settings | Option 1                 | object        | Configuration for using a phone notification channel in a notification rule                                  |
| Option 1         | method [*required*] | enum          | Specifies the method in which a phone is used in a notification rule Allowed enum values: `sms,voice`        |
| Option 1         | type [*required*]   | enum          | Indicates that the notification channel is a phone Allowed enum values: `phone`                              |
| attributes       | delay_minutes            | int64         | The number of minutes that will elapse before this rule is evaluated. 0 indicates immediate evaluation       |
| data             | relationships            | object        | Relationship object for creating a notification rule                                                         |
| relationships    | channel                  | object        | Relationship object for creating a notification rule                                                         |
| channel          | data [*required*]   | object        | Channel relationship data for creating a notification rule                                                   |
| data             | id                       | string        | ID of the notification channel                                                                               |
| data             | type                     | enum          | Indicates that the resource is of type 'notification_channels'. Allowed enum values: `notification_channels` |
| data             | type [*required*]   | enum          | Indicates that the resource is of type 'notification_rules'. Allowed enum values: `notification_rules`       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "category": "high_urgency",
      "delay_minutes": 0
    },
    "relationships": {
      "channel": {
        "data": {
          "id": "7c1ce93f-30a5-596a-0f7b-06bfe153704c",
          "type": "notification_channels"
        }
      }
    },
    "type": "notification_rules"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
A top-level wrapper for a notification rule

| Parent field     | Field                              | Type            | Description                                                                                                   |
| ---------------- | ---------------------------------- | --------------- | ------------------------------------------------------------------------------------------------------------- |
|                  | data [*required*]             | object          | Data for an on-call notification rule                                                                         |
| data             | attributes                         | object          | Attributes for an on-call notification rule.                                                                  |
| attributes       | category                           | enum            | Specifies the category a notification rule will apply to Allowed enum values: `high_urgency,low_urgency`      |
| attributes       | channel_settings                   |  <oneOf>   | Configuration for the associated channel, if necessary                                                        |
| channel_settings | Option 1                           | object          | Configuration for using a phone notification channel in a notification rule                                   |
| Option 1         | method [*required*]           | enum            | Specifies the method in which a phone is used in a notification rule Allowed enum values: `sms,voice`         |
| Option 1         | type [*required*]             | enum            | Indicates that the notification channel is a phone Allowed enum values: `phone`                               |
| attributes       | delay_minutes                      | int64           | The number of minutes that will elapse before this rule is evaluated. 0 indicates immediate evaluation        |
| data             | id                                 | string          | Unique identifier for the rule                                                                                |
| data             | relationships                      | object          | Relationship object for creating a notification rule                                                          |
| relationships    | channel                            | object          | Relationship object for creating a notification rule                                                          |
| channel          | data [*required*]             | object          | Channel relationship data for creating a notification rule                                                    |
| data             | id                                 | string          | ID of the notification channel                                                                                |
| data             | type                               | enum            | Indicates that the resource is of type 'notification_channels'. Allowed enum values: `notification_channels`  |
| data             | type [*required*]             | enum            | Indicates that the resource is of type 'notification_rules'. Allowed enum values: `notification_rules`        |
|                  | included                           | [ <oneOf>] |
| included         | Option 1                           | object          | Data for an on-call notification channel                                                                      |
| Option 1         | attributes                         | object          | Attributes for an on-call notification channel.                                                               |
| attributes       | active                             | boolean         | Whether the notification channel is currently active.                                                         |
| attributes       | config                             |  <oneOf>   | Notification channel configuration                                                                            |
| config           | Option 1                           | object          | Phone notification channel configuration                                                                      |
| Option 1         | formatted_number [*required*] | string          | The formatted international version of Number (e.g. +33 7 1 23 45 67).                                        |
| Option 1         | number [*required*]           | string          | The E-164 formatted phone number (e.g. +3371234567)                                                           |
| Option 1         | region [*required*]           | string          | The ISO 3166-1 alpha-2 two-letter country code.                                                               |
| Option 1         | sms_subscribed_at                  | date-time       | If present, the date the user subscribed this number to SMS messages                                          |
| Option 1         | type [*required*]             | enum            | Indicates that the notification channel is a phone Allowed enum values: `phone`                               |
| Option 1         | verified [*required*]         | boolean         | Indicates whether this phone has been verified by the user in Datadog On-Call                                 |
| config           | Option 2                           | object          | Email notification channel configuration                                                                      |
| Option 2         | address [*required*]          | string          | The e-mail address to be notified                                                                             |
| Option 2         | formats [*required*]          | [string]        | Preferred content formats for notifications.                                                                  |
| Option 2         | type [*required*]             | enum            | Indicates that the notification channel is an e-mail address Allowed enum values: `email`                     |
| config           | Option 3                           | object          | Push notification channel configuration                                                                       |
| Option 3         | application_name [*required*] | string          | The name of the application used to receive push notifications                                                |
| Option 3         | device_name [*required*]      | string          | The name of the mobile device being used                                                                      |
| Option 3         | type [*required*]             | enum            | Indicates that the notification channel is a mobile device for push notifications Allowed enum values: `push` |
| Option 1         | id                                 | string          | Unique identifier for the channel                                                                             |
| Option 1         | type [*required*]             | enum            | Indicates that the resource is of type 'notification_channels'. Allowed enum values: `notification_channels`  |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "category": "high_urgency",
      "channel_settings": {
        "method": "sms",
        "type": "phone"
      },
      "delay_minutes": 1
    },
    "id": "27590dae-47be-4a7d-9abf-8f4e45124020",
    "relationships": {
      "channel": {
        "data": {
          "id": "1562fab3-a8c2-49e2-8f3a-28dcda2405e2",
          "type": "notification_channels"
        }
      }
    },
    "type": "notification_rules"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Path parameters export user_id="00000000-0000-0000-0000-000000000000" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/on-call/users/${user_id}/notification-rules" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "category": "high_urgency",
      "channel_settings": {
        "method": "sms",
        "type": "phone"
      },
      "delay_minutes": 1
    },
    "relationships": {
      "channel": {
        "data": {
          "id": "1562fab3-a8c2-49e2-8f3a-28dcda2405e2",
          "type": "notification_channels"
        }
      }
    },
    "type": "notification_rules"
  }
}
EOF 
                        
##### 

```go
// Create an On-Call notification rule for a user returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "user" in the system
	UserDataID := os.Getenv("USER_DATA_ID")

	// there is a valid "oncall_email_notification_channel" in the system
	OncallEmailNotificationChannelDataID := os.Getenv("ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID")

	body := datadogV2.CreateOnCallNotificationRuleRequest{
		Data: datadogV2.CreateOnCallNotificationRuleRequestData{
			Attributes: &datadogV2.OnCallNotificationRuleRequestAttributes{
				Category:     datadogV2.ONCALLNOTIFICATIONRULECATEGORY_HIGH_URGENCY.Ptr(),
				DelayMinutes: datadog.PtrInt64(0),
			},
			Relationships: &datadogV2.OnCallNotificationRuleRelationships{
				Channel: &datadogV2.OnCallNotificationRuleChannelRelationship{
					Data: datadogV2.OnCallNotificationRuleChannelRelationshipData{
						Id:   datadog.PtrString(OncallEmailNotificationChannelDataID),
						Type: datadogV2.NOTIFICATIONCHANNELTYPE_NOTIFICATION_CHANNELS.Ptr(),
					},
				},
			},
			Type: datadogV2.ONCALLNOTIFICATIONRULETYPE_NOTIFICATION_RULES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewOnCallApi(apiClient)
	resp, r, err := api.CreateUserNotificationRule(ctx, UserDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `OnCallApi.CreateUserNotificationRule`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `OnCallApi.CreateUserNotificationRule`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create an On-Call notification rule for a user returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.OnCallApi;
import com.datadog.api.client.v2.model.CreateOnCallNotificationRuleRequest;
import com.datadog.api.client.v2.model.CreateOnCallNotificationRuleRequestData;
import com.datadog.api.client.v2.model.NotificationChannelType;
import com.datadog.api.client.v2.model.OnCallNotificationRule;
import com.datadog.api.client.v2.model.OnCallNotificationRuleCategory;
import com.datadog.api.client.v2.model.OnCallNotificationRuleChannelRelationship;
import com.datadog.api.client.v2.model.OnCallNotificationRuleChannelRelationshipData;
import com.datadog.api.client.v2.model.OnCallNotificationRuleRelationships;
import com.datadog.api.client.v2.model.OnCallNotificationRuleRequestAttributes;
import com.datadog.api.client.v2.model.OnCallNotificationRuleType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    OnCallApi apiInstance = new OnCallApi(defaultClient);

    // there is a valid "user" in the system
    String USER_DATA_ID = System.getenv("USER_DATA_ID");

    // there is a valid "oncall_email_notification_channel" in the system
    String ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID =
        System.getenv("ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID");

    CreateOnCallNotificationRuleRequest body =
        new CreateOnCallNotificationRuleRequest()
            .data(
                new CreateOnCallNotificationRuleRequestData()
                    .attributes(
                        new OnCallNotificationRuleRequestAttributes()
                            .category(OnCallNotificationRuleCategory.HIGH_URGENCY)
                            .delayMinutes(0L))
                    .relationships(
                        new OnCallNotificationRuleRelationships()
                            .channel(
                                new OnCallNotificationRuleChannelRelationship()
                                    .data(
                                        new OnCallNotificationRuleChannelRelationshipData()
                                            .id(ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID)
                                            .type(NotificationChannelType.NOTIFICATION_CHANNELS))))
                    .type(OnCallNotificationRuleType.NOTIFICATION_RULES));

    try {
      OnCallNotificationRule result = apiInstance.createUserNotificationRule(USER_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OnCallApi#createUserNotificationRule");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create an On-Call notification rule for a user returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.on_call_api import OnCallApi
from datadog_api_client.v2.model.create_on_call_notification_rule_request import CreateOnCallNotificationRuleRequest
from datadog_api_client.v2.model.create_on_call_notification_rule_request_data import (
    CreateOnCallNotificationRuleRequestData,
)
from datadog_api_client.v2.model.notification_channel_type import NotificationChannelType
from datadog_api_client.v2.model.on_call_notification_rule_category import OnCallNotificationRuleCategory
from datadog_api_client.v2.model.on_call_notification_rule_channel_relationship import (
    OnCallNotificationRuleChannelRelationship,
)
from datadog_api_client.v2.model.on_call_notification_rule_channel_relationship_data import (
    OnCallNotificationRuleChannelRelationshipData,
)
from datadog_api_client.v2.model.on_call_notification_rule_relationships import OnCallNotificationRuleRelationships
from datadog_api_client.v2.model.on_call_notification_rule_request_attributes import (
    OnCallNotificationRuleRequestAttributes,
)
from datadog_api_client.v2.model.on_call_notification_rule_type import OnCallNotificationRuleType

# there is a valid "user" in the system
USER_DATA_ID = environ["USER_DATA_ID"]

# there is a valid "oncall_email_notification_channel" in the system
ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID = environ["ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID"]

body = CreateOnCallNotificationRuleRequest(
    data=CreateOnCallNotificationRuleRequestData(
        attributes=OnCallNotificationRuleRequestAttributes(
            category=OnCallNotificationRuleCategory.HIGH_URGENCY,
            delay_minutes=0,
        ),
        relationships=OnCallNotificationRuleRelationships(
            channel=OnCallNotificationRuleChannelRelationship(
                data=OnCallNotificationRuleChannelRelationshipData(
                    id=ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID,
                    type=NotificationChannelType.NOTIFICATION_CHANNELS,
                ),
            ),
        ),
        type=OnCallNotificationRuleType.NOTIFICATION_RULES,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = OnCallApi(api_client)
    response = api_instance.create_user_notification_rule(user_id=USER_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create an On-Call notification rule for a user returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::OnCallAPI.new

# there is a valid "user" in the system
USER_DATA_ID = ENV["USER_DATA_ID"]

# there is a valid "oncall_email_notification_channel" in the system
ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID = ENV["ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID"]

body = DatadogAPIClient::V2::CreateOnCallNotificationRuleRequest.new({
  data: DatadogAPIClient::V2::CreateOnCallNotificationRuleRequestData.new({
    attributes: DatadogAPIClient::V2::OnCallNotificationRuleRequestAttributes.new({
      category: DatadogAPIClient::V2::OnCallNotificationRuleCategory::HIGH_URGENCY,
      delay_minutes: 0,
    }),
    relationships: DatadogAPIClient::V2::OnCallNotificationRuleRelationships.new({
      channel: DatadogAPIClient::V2::OnCallNotificationRuleChannelRelationship.new({
        data: DatadogAPIClient::V2::OnCallNotificationRuleChannelRelationshipData.new({
          id: ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID,
          type: DatadogAPIClient::V2::NotificationChannelType::NOTIFICATION_CHANNELS,
        }),
      }),
    }),
    type: DatadogAPIClient::V2::OnCallNotificationRuleType::NOTIFICATION_RULES,
  }),
})
p api_instance.create_user_notification_rule(USER_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create an On-Call notification rule for a user returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_on_call::OnCallAPI;
use datadog_api_client::datadogV2::model::CreateOnCallNotificationRuleRequest;
use datadog_api_client::datadogV2::model::CreateOnCallNotificationRuleRequestData;
use datadog_api_client::datadogV2::model::NotificationChannelType;
use datadog_api_client::datadogV2::model::OnCallNotificationRuleCategory;
use datadog_api_client::datadogV2::model::OnCallNotificationRuleChannelRelationship;
use datadog_api_client::datadogV2::model::OnCallNotificationRuleChannelRelationshipData;
use datadog_api_client::datadogV2::model::OnCallNotificationRuleRelationships;
use datadog_api_client::datadogV2::model::OnCallNotificationRuleRequestAttributes;
use datadog_api_client::datadogV2::model::OnCallNotificationRuleType;

#[tokio::main]
async fn main() {
    // there is a valid "user" in the system
    let user_data_id = std::env::var("USER_DATA_ID").unwrap();

    // there is a valid "oncall_email_notification_channel" in the system
    let oncall_email_notification_channel_data_id =
        std::env::var("ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID").unwrap();
    let body = CreateOnCallNotificationRuleRequest::new(
        CreateOnCallNotificationRuleRequestData::new(
            OnCallNotificationRuleType::NOTIFICATION_RULES,
        )
        .attributes(
            OnCallNotificationRuleRequestAttributes::new()
                .category(OnCallNotificationRuleCategory::HIGH_URGENCY)
                .delay_minutes(0),
        )
        .relationships(
            OnCallNotificationRuleRelationships::new().channel(
                OnCallNotificationRuleChannelRelationship::new(
                    OnCallNotificationRuleChannelRelationshipData::new()
                        .id(oncall_email_notification_channel_data_id.clone())
                        .type_(NotificationChannelType::NOTIFICATION_CHANNELS),
                ),
            ),
        ),
    );
    let configuration = datadog::Configuration::new();
    let api = OnCallAPI::with_config(configuration);
    let resp = api
        .create_user_notification_rule(user_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create an On-Call notification rule for a user returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.OnCallApi(configuration);

// there is a valid "user" in the system
const USER_DATA_ID = process.env.USER_DATA_ID as string;

// there is a valid "oncall_email_notification_channel" in the system
const ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID = process.env
  .ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID as string;

const params: v2.OnCallApiCreateUserNotificationRuleRequest = {
  body: {
    data: {
      attributes: {
        category: "high_urgency",
        delayMinutes: 0,
      },
      relationships: {
        channel: {
          data: {
            id: ONCALL_EMAIL_NOTIFICATION_CHANNEL_DATA_ID,
            type: "notification_channels",
          },
        },
      },
      type: "notification_rules",
    },
  },
  userId: USER_DATA_ID,
};

apiInstance
  .createUserNotificationRule(params)
  .then((data: v2.OnCallNotificationRule) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
